#ifndef DISKLABEL_H
#define DISKLABEL_H

#define LABELPLACE 64

#ifdef __osf__

typedef unsigned int u32;
typedef unsigned char u8;
typedef unsigned short u16;

#endif

struct disklabel {
      u32 d_magic;
      u16 d_type,d_subtype;
      u8 d_typename[16];
      u8 d_packname[16];
      u32 d_secsize;
      u32 d_nsectors;
      u32 d_ntracks;
      u32 d_ncylinders;
      u32 d_secpercyl;
      u32 d_secprtunit;
      u16 d_sparespertrack;
      u16 d_sparespercyl;
      u32 d_acylinders;
      u16 d_rpm, d_interleave, d_trackskew, d_cylskew;
      u32 d_headswitch, d_trkseek, d_flags;
      u32 d_drivedata[5];
      u32 d_spare[5];
      u32 d_magic2;
      u16 d_checksum;
      u16 d_npartitions;
      u32 d_bbsize, d_sbsize;
      struct d_partition {
	    u32 p_size;
	    u32 p_offset;
	    u32 p_fsize;
	    u8  p_fstype;
	    u8  p_frag;
	    u16 p_cpg;
      } d_partitions[8];
};

#define DISKLABELMAGIC (0x82564557UL)

/* taken from DEC OSF/1 disklabel.h file */
#define	DTYPE_SMD		1		/* SMD, XSMD; VAX hp/up */
#define	DTYPE_MSCP		2		/* MSCP */
#define	DTYPE_DEC		3		/* other DEC (rk, rl) */
#define	DTYPE_SCSI		4		/* SCSI */
#define	DTYPE_ESDI		5		/* ESDI interface */
#define	DTYPE_ST506		6		/* ST506 etc. */
#define	DTYPE_FLOPPY		10		/* floppy */

#define FS_SWAP 1
static char *dktypenames[]={
  "unknown",
  "SMD",
  "MSCP",
  "old DEC",
  "SCSI",
  "ESDI",
  "type 6",
  "type 7",
  "type 8",
  "type 9",
  "floppy",
  0
};

int read_disklabel(int fd,struct disklabel *d);
int dosumlabel(int fd,struct disklabel *d);
int overlaplabel(struct disklabel *d,int offset,int endplace,int num);
#endif
